﻿using System;
using System.Windows;
using System.Windows.Media.Animation;

namespace TestProject
{
    /// <summary>
    /// 커스텀 이징 함수
    /// </summary>
    public class CustomEasingFunction : EasingFunctionBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - CustomEasingFunction()

        /// <summary>
        /// 생성자
        /// </summary>
        public CustomEasingFunction() : base()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 이징 인 처리하기 (코어) - EaseInCore(normalizedTime)

        /// <summary>
        /// 이징 인 처리하기 (코어)
        /// </summary>
        /// <param name="normalizedTime">정규화 시간</param>
        /// <returns>처리 결과</returns>
        protected override double EaseInCore(double normalizedTime)
        {
            return Math.Pow(normalizedTime, 7);
        }

        #endregion
        #region 인스턴스 생성하기 (코어) - CreateInstanceCore()

        /// <summary>
        /// 인스턴스 생성하기 (코어)
        /// </summary>
        /// <returns>생성 인스턴스</returns>
        protected override Freezable CreateInstanceCore()
        {
            return new CustomEasingFunction();
        }

        #endregion
    }
}